<div class="p-formgrid grid">
  <div class="col-12 md:col-8">
    <p-card>
      <ng-template pTemplate="title">
        <div class="flex justify-content-between align-items-center">
          Kategorien
          <p-button
            *urboCmsUiHasPermission="Permission.CategoryWrite"
            icon="pi pi-plus"
            (onClick)="showDialog('category')"
            class="p-button-success p-mt-2"
          ></p-button>
        </div>
      </ng-template>
      <p-accordion>
        <p-accordionTab
          *ngFor="let category of categories; let i = index"
          [header]="category.title.de!"
          class="p-fluid"
        >
          <form #f="ngForm" (ngSubmit)="updateCategory(category)">
            <div class="field">
              <label [for]="'title_de_' + i">Name (deutsch)</label>
              <input
                [id]="'title_de_' + i"
                [name]="'title_de_' + i"
                type="text"
                pInputText
                [(ngModel)]="category.title.de"
                [required]="true"
              />
            </div>
            <div class="field">
              <label [for]="'title_en_' + i">Name (englisch)</label>
              <input
                [id]="'title_en_' + i"
                [name]="'title_en_' + i"
                type="text"
                pInputText
                [(ngModel)]="category.title.en"
                [required]="true"
              />
            </div>
            <div class="field">
              <label [for]="'source_categories_' + i">Quellkategorien</label>
              <p-multiSelect
                [id]="'source_categories_' + i"
                [name]="'source_categories_' + i"
                [options]="allSourceCategories"
                [(ngModel)]="category.sourceCategories"
                [resetFilterOnHide]="true"
                placeholder="Wähle Quellkategorien"
                display="chip"
                [maxSelectedLabels]="99"
              ></p-multiSelect>
            </div>
            <div class="field">
              <label [for]="'icons_' + i">Icon</label>
              <urbo-cms-pois-file-upload
                [currentFilename]="category.filename"
                (fileSelected)="handleFileSelected($event)"
              >
              </urbo-cms-pois-file-upload>
            </div>
            <div class="field">
              <label [for]="'theme_colors_' + i">Farbschema auswählen</label>
              <p-dropdown
                [id]="'theme_colors_' + i"
                [name]="'theme_colors_' + i"
                [options]="config.colorPairs"
                [(ngModel)]="category.colors"
                placeholder="Wähle ein Farbschema"
              >
                <ng-template let-item pTemplate="item">
                  <div style="display: flex; align-items: center">
                    <div
                      [style.backgroundColor]="item.value.lightThemeHexColor"
                      style="
                        width: 20px;
                        height: 20px;
                        margin-right: 10px;
                        border: 1px solid #ccc;
                      "
                    ></div>
                    <div
                      [style.backgroundColor]="item.value.darkThemeHexColor"
                      style="
                        width: 20px;
                        height: 20px;
                        margin-right: 10px;
                        border: 1px solid #ccc;
                      "
                    ></div>
                    <span>{{ item.label }}</span>
                  </div>
                </ng-template>
              </p-dropdown>
              <div class="pt-2" *ngIf="category.colors">
                Ausgewähltes Farbschema:
                <div style="display: flex; align-items: center; gap: 5px">
                  <div
                    [style.backgroundColor]="category.colors.lightThemeHexColor"
                    style="width: 20px; height: 20px; border: 1px solid #ccc"
                  ></div>
                  <span style="margin-right: 10px">Heller Modus</span>
                </div>
                <div
                  style="
                    display: flex;
                    align-items: center;
                    margin-top: 5px;
                    gap: 5px;
                  "
                >
                  <div
                    [style.backgroundColor]="category.colors.darkThemeHexColor"
                    style="width: 20px; height: 20px; border: 1px solid #ccc"
                  ></div>
                  <span style="margin-right: 10px">Dunkler Modus</span>
                </div>
              </div>
            </div>
            <div class="justify-content-end flex">
              <p-progressSpinner
                *ngIf="loading"
                styleClass="w-3rem h-3rem mr-3"
              ></p-progressSpinner>
              <p-button
                *urboCmsUiHasPermission="Permission.CategoryDelete"
                label="Löschen"
                icon="pi pi-trash"
                class="mr-2"
                severity="danger"
                (onClick)="confirmDeleteCategory(category)"
                [disabled]="loading"
              ></p-button>
              <p-button
                *urboCmsUiHasPermission="Permission.CategoryWrite"
                label="Speichern"
                icon="pi pi-save"
                type="submit"
                [disabled]="loading || !f.valid"
              ></p-button>
            </div>
          </form>
        </p-accordionTab>
      </p-accordion>
      <p-confirmDialog></p-confirmDialog>
    </p-card>
  </div>
  <div class="col-12 md:col-4">
    <urbo-cms-pois-unmapped-categories
      [unmappedSourceCategories]="unmappedSourceCategories"
    ></urbo-cms-pois-unmapped-categories>
  </div>
</div>

<urbo-cms-pois-poi-new-category
  (created)="loadContent()"
  (updated)="loadContent()"
  [activeTabIndex]="0"
  [categoryToEdit]="categoryToEdit"
></urbo-cms-pois-poi-new-category>
